// "atomic" I/O on sockets
//
// Author: Pierre Lombard <pierre.lombard@imag.fr> 2002/07 GPLv2

#ifndef __SURE_SOCK_H__
#define __SURE_SOCK_H__ 1

#include <sys/types.h>

/* These functions are aimed at working with synchronous sockets
 * There are only 3 return values possible:
 *    -1   an error occured
 *    0    connection closed by peer before len bytes are read/written
 *    len  the I/O is successful
 * 
 * Note:
 *   read uses recv with flags set to 0
 *   write uses send with flags set to 0
 * 
 * */

int sure_recv(int s, void *buf, size_t len, int flags);
int sure_send(int s, const void *msg, size_t len, int flags);

ssize_t sure_read(int fd, void *buf, size_t count);
ssize_t sure_write(int fd, const void *buf, size_t count);
#endif

